#!/usr/bin/perl -w
# ianb@nessie.mcc.ac.uk 20031019
# $Id: mp3lint-tools.pod.PL,v 1.2 2003/10/26 19:32:00 ianb Exp $
# Create mp3lint-tools.pod from the docs for all the tools.
use strict;
use Cwd;
use Pod::Select;

my $me=($0=~/(?:.*\/)?(.*)/)[0];

chdir("docs") or die("$me: cannot chdir to docs/: $!\n");

my $toolspath="../lib/MP3/Archive/Lint/Tools/";

my $outfile="mp3lint-tools.pod";
my $tmpfile="mp3lint-tools.tmp";
my $startfile="mp3lint-tools.start";
my $endfile="mp3lint-tools.end";
my $OVERWRITE=0; my $APPEND=1;

my @tools=();

opendir(D,$toolspath) or die("$me: $toolspath: opendir: $!\n");
while($_=readdir(D))
{
	if(/^([A-Z].*)\.pm$/)
	{
		push(@tools,Cwd::abs_path($toolspath)."/$_");
	}
}
closedir(D) or die("$me: $toolspath: closedir: $!\n");

writefile($outfile,$startfile,$OVERWRITE);

open(W,">>$outfile") or die("$me: cannot open $outfile: $!\n");
# podselect only writes to a file the output from the last file,
# hence this hack

$SIG{PIPE}='IGNORE';

my $pid=open(PIPE,"-|");
unless(defined($pid)) { die("$me: cannot fork: $!\n"); }

if(!$pid) #child
{
	podselect(sort(@tools));
	exit 0;
}
# parent
print W <PIPE>;
close(PIPE) or die("$me: error running child process: $?\n"); 
close(W) or die("$me: error closing $outfile: $!\n");

writefile($outfile,$endfile,$APPEND);

sub writefile
{
	my ($writef,$readf,$mode)=@_;
	my $writefile=">".$writef;
	if($mode == $APPEND)
	{
		$writefile=">".$writefile;
	}
	
	open(W,$writefile) or die("$me: cannot open $writef for writing: $!\n");
	open(F,$readf) or die("Cannot open $readf: $!\n");
	print W <F>;
	close(F) or die("Cannot close $readf: $!\n");
	close(W) or die("$me: cannot close $writef: $!\n");
}


